 Program CopyBOOT;
 { Provede  zkoprovn souboru  BOOT_NEW.DAT  do zavdcho }
 { sektoru. P O Z O R na spravn obsah souboru  BOOT_NEW.DAT }
 { v zvislosti na formtu diskety.                          }
 {}
 { Copyright (c) Vt Maleek, Lidick  33,  795  01  Rmaov }
 {}
  uses
   Crt, Dos;
  const
   BFN = 'BOOT_NEW.DAT';
  type
   SektElT = array [1..512] of byte;  {Buffer pro jeden sektor}
  var
   SektEl: SektElT;
   R: registers;
   BF: file;
   P:pointer;
   YN: char;
   Kolik: word;

  Function TestFile: byte;
   var IOR: byte;
    {Vrac hodnotu IOResult pi pokusu o oteven souboru BF}
   begin
    {$I-}
    Reset(BF);
    IOR:=IOResult;
    If IOR=0 then Close(BF);
    TestFile:=IOR;
    {$I+}
   end; {TestFile}

  Procedure ReadFromFile;
   {Zape obsah souboru do zavdcho sektoru}
   var I: integer;
   begin
    Assign(BF,BFN);
    If TestFile<>0 then begin
     Writeln('Nenalezen ',BFN);
     Halt(1);
    end;
    Reset(BF,512);
    BlockRead(BF,SektEl,1,Kolik);
    Close(BF);
   end; {ReadFromFile}

  Function Continue: boolean;
   {Dotaz na opakovn zpisu na disketu pi nespchu}
   begin
    Continue:=False;
    Writeln;
    Write('Opakovat zpis na disketu ? [A/N]: ');
    YN:=readkey; writeln(UpCase(YN));
    If UpCase(YN)='A' then Continue:=True;
   end; {Continue}

  Procedure Pis;
   {Pepis pvodnho zavdcho sektoru}
   var
    X: integer;
   begin
    repeat
     ReadFromFile;
     P:=@SektEl;
     r.ah:=3;  { slo podfunkce }
     r.al:=1;  { Kolik sektor }
     r.ch:=0;  { stopa  }
     r.cl:=1;  { sektor }
     r.dh:=0;  { povrch }
     r.dl:=0;  { identifikace jednotky A: }
     r.es:=seg(P^);
     r.bx:=ofs(P^);         {adresa buferu}
     intr($13,r);
     writeln(' ..... R.AH =',R.AH:2);
     If (R.AH<>0) and (R.AH<>6) then
     If not Continue then R.AH:=0;
    until R.AH = 0;
   end;   { End Of Pis }

  begin { MAIN }
   { Inicializace bufferu }
   For Kolik:=1 to 512 do SektEl[Kolik]:=100;
   ClrScr;
   writeln('Vlo clovou disketu a stiskni klvesu.....');
   YN:=ReadKey;
   Pis;
  end.