Unit DeathWin2;

InterFace
Uses App, Dialogs, Objects, Views;
Type Proc = Procedure;
Type PUnRemoveAble = ^TUnRemoveAble;
  (*Ukazatel na TUnRemoveAble*)
  TUnRemoveAble = Object (TDialog) (*"Mrtv" okno*)
  Operation:Procedure; (*Co se m provdt za operaci*)
  Constructor Init(Rect:TRect;Title1:String;Oper:Proc);
  Function Execute:Word;Virtual;
End;

Procedure UnRemoveAbleBoxRect(Rect:TRect;Titul,
  Text:String;Operace:Proc);

Procedure UnRemoveAbleBox(Titul,
  Text:String;Operace:Proc);
Implementation
   Constructor
   TUnRemoveAble.Init(Rect:TRect;Title1:String;Oper:Proc);
      Begin
         TDialog.Init(Rect, Title1);
         (*Voln konstruktoru pedka*)
         Operation:= Oper;
         (*Nastaven operace, kter m bt provdna*)
         Flags:= 0;
         (*Nastaven pole TUnRemoveAble.Flag, aby bylo okno
         skuten mrtv*)
      End;
   Function TUnRemoveAble.Execute:Word;
      Begin
         If @Operation<>Nil then Operation;
         (*Prove zadanou operaci*)
         Execute:= cmClose;(*A te okno sm zavi*)
      End;

   Procedure UnRemoveAbleBoxRect(Rect:TRect;Titul,
      Text:String;Operace:Proc);
      Var UnRemoveAble:PUnRemoveable;
          View:PView;
      Begin
         UnRemoveAble:= New(PUnRemoveAble,
                              Init(Rect, Titul, Operace));
         With UnRemoveAble^ do
         Begin
         (*Vloen zadanho textu do okna*)
         Rect.Assign(3, 2, Size.X - 2, Size.Y - 3);
         View:= New(PStaticText, Init(Rect, Text));
         Insert(View);
         End;
         Desktop^.ExecView(UnRemoveAble);
         (*Umstn na plochu*)
         Dispose(UnremoveAble, Done);
      End;

   Procedure UnRemoveAbleBox(Titul,Text:String;
      Operace:Proc);
      Var Rect:TRect;
      Begin
         Rect.Assign(20, 8, 60, 17);
         UnRemoveAbleBoxRect(Rect,Titul,Text,Operace);
      End;
End.



Program DeathHallo;
Uses App, DeathWin2, Drivers, Objects, CRT;
Var MyApp:TApplication;
    Act:Proc;
    Rect:TRect;

Procedure Action;
   Begin
      Sound(100);
      Delay(100);
      NoSound;
      Delay(500);
   End;

Begin
MyApp.Init;
Rect.Assign(5,5,30,15);
UnremoveAbleBoxRect(Rect,'Hallono.1',^C'Halloworld!!!',Act);
Rect.Assign(15,10,40,20);
UnremoveAbleBoxRect(Rect,'Hallono.2',^C'Halloworld!!!',Act);
Rect.Assign(20,15,45,22);
UnremoveAbleBoxRect(Rect,'Hallono.3',^C'Halloworld!!!',Act);
Rect.Assign(25,5,50,20);
UnremoveAbleBoxRect(Rect,'Hallono.4',^C'Halloworld!!!',Act);
Rect.Assign(10,15,50,22);
UnremoveAbleBoxRect(Rect,'Hallono.5',^C'Halloworld!!!',Act);
UnremoveAbleBox('Hallono.6',^C'Halloworld!!!',Act);
(*Standardnvelikostaumistnokna*)
   MyApp.Done;
End.
