Unit Dlazba_U;
Interface
 uses Graph, Crt;
 const RangeMax = 999;          {Maximln poet prvk}
 type
  Range = 0..RangeMAx;
  Location = object       {Rodi vech dalch objekt}
    X,Y: Integer;
    Procedure Init(InitX,   InitY:   Integer);
    Function GetX: Integer; Function GetY: Integer;
  end; {Location}
  PointPtr = ^Point;
  Point = object (Location)                {Objekt bod}
    Visible: Boolean;            {Je objekt viditeln?}
    KNum: 1..RangeMax; KNumStr: String; {slo objektu}
    Constructor Init(InitX,InitY:Integer); {Vytvo bod}
    Destructor Done; virtual;     {Uvolni bod z pamti}
    Function   GetDelta(var DX:Integer;var DY:Integer;
                        var FigX,FigY:Integer):Boolean;
    Procedure  Show; virtual; Procedure  Hide; virtual;
    Function   IsVisible: Boolean;   {Je prvek vidit.?}
    Procedure  MoveTo(NewX, NewY: Integer);    {Pesu}
    Procedure  Drag(DragBy: Integer); virtual; {Thni }
  end; {Point}
  KachlikPtr = ^Kachlik;
  Kachlik = object (Point)   {Objekt - prvek "kachlk"}
    Width,High:Integer; WStr,HStr:String;{Rozmry prv.}
    Width1,High1: Integer;
    Board, ForeC, BcgC: Byte;             {Barvy prvku}
    Constructor Init(InitX,InitY: Integer; InitW,InitH:
          Real;InitF, InitBcg, InitB: Byte; KN: Range);
    Destructor  Done; virtual; Procedure Show; virtual;
    Procedure   Hide; virtual; Procedure Rotate;
  end; {Kachlik}
 Function Data: Boolean;     {te data z text. souboru}
 var
  KeyChar: Char;  Ind: Range;  PKachlik: KachlikPtr;
  PArrK: Array [1..RangeMax] of KachlikPtr;
  IndMax:Range;W,H,S:Integer;WB,HB:Real;XRel,YRel:Real;
Implementation
 Function Data;  {te charakteristiky prvku ze souboru}
  var FD: Text; Ckl, PKPom, B, F: Byte;
  begin
   For Ind:=1 to RangeMax do PArrK[Ind]:=Nil;{Inicial.}
   Assign(FD,'DLAZBA.DAT');     {Textov soubor s daty}
   {$I-} Reset(FD); {$I+}
   If IOResult <> 0 Then Data:=False {Soub. neexistuje}
   else begin Ind:=0;        {Soubor   nalezen}
    While not Eof(FD) do begin
     Readln(FD,W,H,B,F,PKPom);  {Charakteristiky prvku}
     For Ckl:=1 to PKPom do begin  {Vkldm nov prvky}
      PArrK[Ckl+Ind]:=New(KachlikPtr,Init(0,
      (GetMaxY div 2), W, H, B, F, 7, Ind+Ckl));
     end; {for}                    {Prvek byl vytvoen}
     Ind:=Ind+PkPom;
    end; {while}
    Close(FD); Data:=True;
    IndMax:=Ind; Data:=True;
   end; {else}
  end; {Data}
 Procedure RedrawAll;       {Pekresli celou obrazovku}
  var IndLok: 1..RangeMAx;
  begin
   SetFillStyle(1,7);   {Nakresl podklad, zkl. desku}
   Bar3D(0,0,GetMaxX,GetMaxY div 2,0,False); IndLok:=1;
   While PArrK[IndLok] <> Nil do begin
    PArrK[IndLok]^.Show;{Zobraz prv.} IndLok:=IndLok+1;
   end; {while}
  end; {RedrawAll}
 Procedure Location.Init(InitX, InitY: Integer);
  begin X := InitX; Y := InitY; end; {Uri vch.polohu}
 Function Location.GetX: Integer; {Zjisti X-ovou sou.}
  begin GetX := X; end;
 Function Location.GetY: Integer; {Zjisti Y-ovou sou.}
  begin GetY := Y; end;
 Constructor Point.Init(InitX, InitY: Integer);
  begin Location.Init(InitX,InitY);Visible:=False; end;
 Destructor Point.Done;
  begin Hide; end;
 Procedure Point.Show;
  begin Visible:=True; PutPixel(X,Y,GetColor); end;
 Procedure Point.Hide;
  begin Visible:=False; PutPixel(X,Y,GetBkColor); end;
 Function Point.IsVisible: Boolean;
  begin IsVisible := Visible; end;
 Procedure Point.MoveTo(NewX, NewY: Integer);
  begin Hide; X := NewX; Y := NewY; Show; end;
 Function Point.GetDelta(var DX:Integer;var DY:Integer;
                     var FigX, FigY: Integer): Boolean;
  var Quit: Boolean;
  Function ObjectNumber: Range;
   var OldX, OldY, Code,   ObjNP:    Integer;
       Msg,  ObjN: String; Ch: Char; OK: Boolean;
   begin
    OK:=True;
    repeat
     OldX:=Graph.GetX;OldY:=Graph.GetY;Msg:='Prvek .';
     Graph.MoveTo(0,GetMaxY-TextHeight('T'));
     OutText(Msg); ObjN:='';
     repeat
      Ch:=ReadKey;
      If Ch in ['0'..'9'] then begin
      ObjN:=ObjN+Ch; OutText(Ch); end;
     until Ch=#13;
     Val(ObjN,ObjNP,Code);
     If Code=0 then begin
      Graph.MoveTo(OldX, OldY); ClearDevice;
      If (ObjNP>IndMax)or(ObjNP<1)or(Code<>0) then
      OK:=False else OK:=True; end; {if Code}
    until OK;
    ObjectNumber:=ObjNP;
   end; {ObjectNumber}
  begin  {Point.GetDelta}
   DX:=0; DY:=0; GetDelta:=True;
   repeat
     KeyChar:=ReadKey; Quit:=True;
     case Ord(KeyChar) of
        0: begin                 {2 bytov kd klvesy}
             KeyChar := ReadKey; {Druh  byte  klvesy}
             case Ord(KeyChar) of
              72: DY := -1;             {ipka  nahoru}
              80: DY := 1;              {ipka    dol}
              75: DX := -1;             {ipka   vlevo}
              77: DX := 1;              {ipka  vpravo}
              else Quit := False; {Jinou klv. ignoruj}
             end; { case }
           end;
       68,100: RedrawAll;        {Pekresli obrazovvku}
   {R} 82,114: begin PArrK[Ind]^.Rotate;RedrawAll; end;
   {<ESC>} 27: GetDelta := False; {Stisk <ESC>, skonci}
       49..57: begin          {Vbr akt. prvku 1 a 9}
                If Ord(KeyChar)-48 <= IndMax then
                Ind:=Ord(KeyChar)-48;
                Quit:=False; PArrK[Ind]^.Show;
               end;
   {0}     48: Ind:=ObjectNumber; {Dotaz na s. prvku}
         else  Quit := False;     {Jinou klv. ignoruj}
     end;  { case }
   until Quit;
   FigX:=PArrK[Ind]^.X; FigY:=PArrK[Ind]^.Y; RedrawAll;
  end; {Point.GetDelta}
 Procedure Point.Drag(DragBy: Integer);
  var DX, DY, FgX, FgY, FigX, FigY: Integer;
  begin
   Show; FgX:=GetX; FgY:=GetY;  {Zobraz a zjisti sou.}
   while GetDelta(DX,DY,FigX,FigY) do begin
    With PArrK[Ind]^ do begin
     FgX:=FigX; FgY:=FigY;  FgX:=FgX+(DX*DragBy);
     FgY:=FgY+(DY*DragBy);  MoveTo(FgX,FgY);
    end; {with}
   end; {while}
  end; {Point.Drag}
 Constructor Kachlik.Init(InitX,InitY:Integer; InitW,
      InitH: Real; InitF,InitBcg,InitB:Byte; KN:Range);
  var I, J: Byte;
  begin
   Point.Init(InitX, InitY); Str(InitW:6:0,WStr); I:=1;
   While WStr[1]=' ' do begin
    For J:=1 to Length(WStr)-1 do WStr[J]:=WStr[J+1];
    Inc(I);
   end; {while}
   WStr[0]:=Chr(Length(WStr)-I+1); Str(InitH:6:0,HStr);
   I:=1;
   While HStr[1]=' ' do begin
    For J:=1 to Length(HStr)-1 do HStr[J]:=HStr[J+1];
    Inc(I);
   end; {while}
   HStr[0]:=Chr(Length(HStr)-I+1);
   Width:=Trunc(XRel*InitW); {Skuten  ka a  vka}
   High:=Trunc(YRel*InitH);  {pepot. na pocet pixelu}
   Width1:=Trunc(XRel*InitH); {Skuten  ka a  vka}
   High1:=Trunc(YRel*InitW);  {pepot. na pocet pixelu}
   BcgC:=InitBcg; ForeC:=InitF; Board:=InitB; KNum:=KN;
   Str(KNum,KNumStr);
  end;  {Kachlik.Init}
 Destructor Kachlik.Done;
  begin Dispose(PArrK[Ind]); PArrK[Ind]:=Nil; end;
 Procedure Kachlik.Show;
  var OldTextType: TextSettingsType;
  begin
   Visible:=True; SetFillStyle(1,BcgC);  {Kresli prvek}
   Graph.Bar3D(X,Y,X+Width,Y+High,0,False);
   If (TextWidth(KnumStr)<Width-2) and (TextHeight('T')
      <High-2) then OutTextXY(X+2,Y+2,KNumStr);
   If TextWidth(WStr)<Width-2 then {Zobraz. e prvku}
   OutTextXY(X+2,Y+High-TextHeight('T'),WStr);
   If TextWidth(HStr)<High-2 then begin {Z.vky prvku}
    GetTextSettings(OldTextType);
    SetTextStyle(OldTextType.Font,VertDir,
                 OldTextType.CharSize);
    OutTextXY(X+Width{-TextHeight('T')},Y+2,HStr);
    SetTextStyle(OldTextType.Font,OldTextType.Direction
                ,OldTextType.CharSize);
   end;
  end; {Kachlik.Show}
 Procedure Kachlik.Hide;
  var TempColor: Word;
  begin
   TempColor:=Graph.GetColor;
   SetColor(GetBkColor); SetFillStyle(1,GetBkColor);
   Visible:=False; Bar3D(X,Y,X+Width,Y+High,0,False);
   SetColor(TempColor);
  end; {Hide}
 Procedure Kachlik.Rotate;
  var PomW: Integer; PomS: String;
  begin
   Hide; PomS:=WStr; WStr:=HStr; HStr:=PomS;
   PomW:=Width; Width:=Width1; Width1:=PomW;
   PomW:=High;  High :=High1;  High1 :=PomW; Show;
  end;
end.
