program EpsonPrt;
uses Printer,Graph;
var
   L,Gd,Gm:Integer;
   St:string[80];

procedure EpsonHC(Xl,Yl, {souradnice leveho horniho}
                  Xp,Yp, {praveho dolniho rohu obdelniku na obrazovce}
                  Rozliseni,{v DPI; 0-60;1-120;2-120;3-240}
                  Okraj,    {levy okraj v pixelech}
                  BkColor:Word {barva pozadi}
                 );
const
   Esc=#27;
var
   PocByte,PocBit,Row,Col,C,Ys,N1,N2,Znak,J:Integer;
begin
   Write(lst,Esc,'3',Chr(24)); {nastaveni radkovani}
         N1:=(Xp-Xl+1+Okraj) mod 256;    {dolni bajt}
         N2:=(Xp-Xl+1+Okraj) div 256;    {horni bajt udavajici pocet bajtu}
                                   {tisknutych v grafickem rezimu}
         PocByte:=(Yp-Yl+1) div 8;
         PocBit:=(Yp-Yl+1) mod 8;
         for Row:=0 to PocByte-1 do
            begin
               Write(lst,Esc,'*',Chr(Rozliseni),Chr(N1),Chr(N2));
               for Col:=1 to Okraj do
                  Write(lst,Chr(0));
               for Col:=Xl to Xp do
                  begin
                     Znak:=0;
                     for J:=0 to 7 do
                        begin
                           Ys:=Yl+8*Row + J;
                           C:=GetPixel(Col,Ys);
                           if C<>BkColor then
                              Znak:=Znak+128 shr J;
                        end;
                        Write(lst,Chr(Znak))
                  end;
               Writeln(lst)
            end;
         if PocBit>0 then
            begin
              Write(lst,Esc,'*',Chr(Rozliseni),Chr(N1),Chr(N2));
              for Col:=1 to Okraj do
                  Write(lst,Chr(0));
              for Col:=Xl to Xp do
                  begin
                     Znak:=0;
                     for J:=0 to PocBit-1 do
                        begin
                           Ys:=Yl+8*PocByte+J;
                           C:=GetPixel(Col,Ys);
                           if C<>BkColor then
                              Znak:=Znak+128 shr J;
                        end;
                        Write(lst,Chr(Znak))
                  end;
              Writeln(lst);
            end;
         Write(lst,Esc,'2');
end;
begin
  DetectGraph(Gd,Gm);
  InitGraph(Gd,Gm,'..\bgi');
  MoveTo(0,0);
  LineTo(GetMaxX,GetMaxY);
  MoveTo(0,GetMaxY);
  LineTo(GetMaxX,0);
  St:='TOTO JE KOPIE OBRAZOVKY TISKARNOU EPSON';
  L:= TextWidth(St);
  OutTextXY(GetMaxX div 2 - L div 2,50,St);
  Rectangle(0,0,GetMaxX,GetMaxY);
  Rectangle(100,100,GetMaxX-100,GetMaxY-100);
  Rectangle(10,23,20,33);
  EpsonHc(0,0,     {souradnice leveho horniho}
          GetMaxX,GetMaxY,{praveho dolniho rohu obdelniku na obrazovce}
          3,   {v DPI ;0-60;1-120;2-120;3-240}
          100,  {levy okraj 100 pixelu}
          Black {barva pozadi}
         );
  readln;
  CloseGraph;
end.