Program Run;
{Program pro odkladani druheho sektoru libovolneho souboru a jeho obnovu.}
{Program je pouzivan pro spousteni libovolneho programu prostredn. hesla.}
uses Crt;
 const
  BufLength = 512;
  PswOk = 'byte';
  FNameOut: PathStr = 'DESTROY.DAT';
 var
  F, FOut: File; FName: String;
  Kolik: Word; Psw: String[4];
  Buf, BufNew: Array [1..BufLength] of byte;

 Procedure Warring(WarrMsg: String);
  {Vpis etzce WarrMsg a ukonen programu}
  begin
   ClrScr; Writeln(WarrMsg);
   Delay(999); ClrScr;
  GotoXY(1,25); Halt(1);
  end; {Warring}

 Procedure GetPassword;
  {Dotaz na heslo}
  begin
  Write('Heslo: '); Readln(Psw);
   If Psw <> PswOK then
   Warring('C h y b n e h e s l o ...'+#7); 
  end; {GetPassword}

Function TestFile(TestF: String; Hlt: Boolean): Boolean;
  { Zjist existenci souboru TestF. Pokud neexistuje a }
  { Hlt je True, program se ukon. }
  var
   TF: File;
  begin
   Assign(TF,TestF);
   {$I-} Reset(TF,1); {$I+}
   If IOResult <> 0 then begin
    If Hlt then Warring('Neexistuje '+TestF);
    TestFile:=False;
   end
   else begin
    TestFile:=True;
    Close(TF);
   end;
  end; {TestFile}

 Procedure GetParam;
  {Zjist/Vyd nzev chrnnho programu}
 begin
   If ParamCount = 1 then FName:=ParamStr(1)
   else begin
    Write('Nazev chranen. progr.: ');
    Readln(FName);
   end;
   Assign(F,FName);
   If TestFile(FName,True) then Reset(F,1);
  end; {Parametry}

 Procedure Read2NdSec;
  {Pete druh sektor danho "exefajlu" }
  {a ulo jej, potom pepis "exefajlu". }
  begin
   Seek(F,512);
   BlockRead(F,Buf,SizeOf(Buf),Kolik);
   Seek(F,512);
  BlockWrite(FOut,Buf,SizeOf(Buf),Kolik);
   BlockWrite(F,BufNew,SizeOf(BufNew),Kolik);
   Close(F); Close(FOut);
  end; {CtiDruhySek}

 Procedure Write2NdSec;
  {Zvolen soubor zkopruje na msto druhho sektoru}
  begin
  BlockRead(FOut,Buf,SizeOf(Buf),Kolik);
   Seek(F,512);
   BlockWrite(F,Buf,SizeOf(Buf),Kolik);
   Close(FOut); Close(F);
  end; {Write2NdSec}

 Procedure GenRandomSector;
  {Generuje nhodn sektor}
  var Q: Integer;
  begin
   Randomize;           {Naplnn "nesmysly"}
   For Q:=1 to 512 do BufNew[Q]:=Random(254);
 end; {GenRandomSector}

 Procedure Restore;
  {Uveden "exefajlu" do pvodnho stavu}
 begin
  Assign(FOut,FNameOut);
  Reset(FOut,1);
  Write2NdSec;
  Erase(Fout);
 end; {Restore}

Procedure Destroy;
 {Naruen - destrukce "exefajlu"}
 begin
  Assign(FOut,FNameOut);
  Rewrite(FOut,1);
  GenRandomSector;
  Read2NdSec;
 end; {Destroy}

begin {MAIN}
 GetParam;
 If TestFile(FNameOut,False) then begin
  GetPassword;
  Restore
 end
 else Destroy;
end.


