Program Run;
{Program  pro  vzajemne  prehozeni  prvniho a druheho sektoru libovolneho}
{souboru.Pouziti: spousteni libovolneho "exefajlu" prostrednictvim hesla.}
uses Crt;
const
 BufLength = 512;
 PswOk     = 'byte';
var
 F: File;
 FName:   String;
 Psw:     String[4];
 Kolik:   Word;

Procedure Warring(WarrMsg: String);
 {Vpis etzce WarrMsg a ukonen programu}
 begin
  ClrScr;       Writeln(WarrMsg);
  Delay(999);   ClrScr;
  GotoXY(1,25); Halt(1);
 end; {Warring}

Procedure GetPassword;
 {Dotaz na heslo}
 begin
  Write('Heslo: '); Readln(Psw);
  If Psw <> PswOK   then
  Warring('C h y b n e   h e s l o ...'+#7);
 end; {GetPassword}

Function TestFile(TestF: String): Boolean;
 { Zjist existenci souboru TestF }
 var
  TF: File;
 begin
  Assign(TF,TestF);
  {$I-} Reset(TF,1); {$I+}
  If IOResult <> 0 then Warring('Neexistuje '+TestF)
  else begin
   TestFile:=True;
   Close(TF);
  end;
 end; {TestFile}

Procedure GetParam;
 {Zjist/Vyd nzev chrnnho programu}
 begin
  If ParamCount = 1 then FName:=ParamStr(1)
  else begin
   Write('Nazev chranen. progr.: ');
   Readln(FName);
  end;
  Assign(F,FName);
  If TestFile(FName) then Reset(F,1);
 end; {Parametry}

Procedure ChangeSectors;
 {Prohodi sektory}
 var
  Buf1, Buf2: Array [1..BufLength] of byte;
 begin
  BlockRead(F,Buf1,SizeOf(Buf1),Kolik);
  BlockRead(F,Buf2,SizeOf(Buf2),Kolik);
  If (Buf1[1]<>Ord('M'))and(Buf1[2]<>Ord('Z'))
  then GetPassword;
  Seek(F,0);
  BlockWrite(F,Buf2,SizeOf(Buf2),Kolik);
  BlockWrite(F,Buf1,SizeOf(Buf1),Kolik);
  Close(F);
 end; {ChangeSectors}

begin {MAIN}
 GetParam;
 ChangeSectors;
end.

@LH 3
