program LaserPrt;
{hardcopy obrazovky na laserove tiskarne rastrovou grafikou}
uses Printer,Graph;
var
   Gd,Gm:Integer;
   L:Integer;
   St:String;
procedure LaserHC(Xl,Yl,     {souradnice leveho horniho}
                  Xp,Yp,     {praveho dolniho rohu obdelniku na obrazovce}
                  Orientation, {0 - Portrait; 1 - Landscape}
                  Rozliseni,   {v "bodech" na palec - 75, 100, 150, 300}
                  PozX,PozY,   {pozice leveho horniho rohu na strance}
                  BkColor:Word {barva pozadi obrazovky}
                 );
const
  Esc=#27;
var
  By,Bi,I,Znak,Row,C,PocByte,PocBit:Integer;
  Radek:String[80];
begin
  PocByte:=(Xp-Xl+1) div 8;
  PocBit:=(Xp-Xl+1) mod 8;
  write(lst,Esc,'&l',Orientation,'O');
  write(lst,Esc,'*r',0,'F');{presentacni mod nastaveny tak, ze
                             bere v uvahu logickou orientaci stranky}
  write(lst,Esc,'*p',PozX,'x',Esc,'*p',PozY,'Y');
  {nastaveni zacatku stranky}
  write(lst,Esc,'*t',Rozliseni,'R');
  {nastaveni rozliseni}
  write(lst,Esc,'*r',1,'A');
  {start rezimu rastrove grafiky}
  for Row:=Yl to Yp do
     begin
       Radek:='';
       for By:=0 to PocByte-1 do
          begin
            Znak:=0;
            for I:=0 to 7 do
               begin
                 C:=GetPixel(Xl+By*8+I,Row);
                 if C<>BkColor then Znak:=Znak+ 128 shr I;
               end;
            Radek:=Radek+Chr(Znak);
          end;
       Znak:=0;
       for Bi:=0 to PocBit-1 do
          begin
            C:=GetPixel(Xl+PocByte*8+Bi,Row);
            if C<>BkColor then Znak:=Znak+ 128 shr Bi;
          end;
       if PocBit>0 then
           Radek:=Radek+Chr(Znak);
       write(lst,Esc,'*b',Length(Radek),'W',Radek);
     end;
  write(lst,Esc,'*rB'); {konec prenosu}
  write(lst,#12);{new page}
end;
begin
  DetectGraph(Gd,Gm);
  InitGraph(Gd,Gm,'..\bgi');
  MoveTo(0,0);
  LineTo(GetMaxX,GetMaxY);
  MoveTo(0,GetMaxY);
  LineTo(GetMaxX,0);
  St:='TOTO JE KOPIE OBRAZOVKY LASEROVKOU';
  L:= TextWidth(St);
  OutTextXY(GetMaxX div 2 - L div 2,50,St);
  Rectangle(0,0,GetMaxX,GetMaxY);
  Rectangle(100,100,GetMaxX-100,GetMaxY-100);
  LaserHC(0,0,     {souradnice leveho horniho}
          GetMaxX,GetMaxY, {praveho dolniho rohu obdelniku na obrazovce}
          1,       {Landscape}
          75,   {v "bodech" na palec - 75, 100, 150, 300}
          200,100,   {pozice leveho horniho rohu na strance}
          Black {barva pozadi}
         );
  readln;
  CloseGraph;
end.
