Program Scitacka;
 {$X+}
 {$M 16384,0,20000}
 uses Views,App,Drivers,Objects,Dialogs,
      Menus,Memory,MsgBox,Dos,Crt;
 const
  Mz4 = #32#32#32#32;      hcN = hcNoContext;
  cmKalk=100; cmSecti=101; cmAboutOn=102; cmAboutOff=103;
  KalkReady = 'R E A D Y'+Mz4;
 type
  TKalkData = record  {Datov zznam s sly pro stn}
   Cis1 : String[3];
   Cis2 : String[3];
  end; {TKalkData}
  PDisplayKalk = ^TDisplayKalk;          {Objekt display}
  TDisplayKalk = object(TView)
   DspRsl:     String; {Vsledek soutu ve form etzce}
   Constructor Init(R: TRect);
   Procedure   DrawView; virtual;
   Procedure   Draw; virtual;
  end; {TDisplayKalk}
  PKalkulator = ^TKalkulator;         {Objekt kalkulaka}
  TKalkulator = object(TDialog)
   Dsp1, Dsp2: PView;       {Ukazatel na objekt stanec}
   Vysl:       Integer;                 {Vsledek soutu}
   PDisplay:   PDisplayKalk; {Ukazatel na objekt display}
   KalkData  : TKalkData;
   Constructor Init;
   Procedure   Secti;                   {Vlastn stn}
   Procedure   HandleEvent(var Event: TEvent); virtual;
  end; {TKalkulator}
  PAboutViewer = ^TAboutViewer; {Potomek tzv. prohliee}
  TAboutViewer = object(TScroller)
   Constructor Init(var R:TRect; AHSc,AVSc:PScrollBar);
   Procedure Draw; virtual;
  end; {TAboutViewer}
  PAbout = ^TAbout;
  TAbout = object(TWindow)
   AboutViewer: PAboutViewer;
   Constructor Init;
  end; {TAbout}

  PMemory = ^TMemory;   {Objekt  zjiujc volnou pam}
  TMemory = object(TView)
   MemorySpace: string[13];    {Voln pam v kilobytech}
   UpDown:      Boolean;         {Vbr indikan znaky}
   Constructor Init(var R: TRect);
   Procedure   Draw; virtual;
   Function    FormatMemorySpace(MSpace: Real): String;
   Function    Update: LongInt; virtual;
  end; {TMemory}
  TKalkApp = object(TApplication)
   PAb:  PAbout;
   PMem: PMemory;
   Constructor Init;
   Procedure   AboutOn;   {Zobraz  informace o autorovi}
   Procedure   AboutOff;  {"Zhasne" informace o autorovi}
   Procedure   Kalk;                {Vyvoln kalkulaky}
   Procedure   InitMenuBar;    virtual; {Inicial.   menu}
   Procedure   InitStatusLine; virtual; {Inic. stav.d.}
   Procedure   Idle; virtual;  {Aktivace objektu TMemory}
   Procedure   HandleEvent(var Event: TEvent); virtual;
  end; {TKalkApp}
 var
  VyslStr: String[128];
 {==== TDisplayKalk Methods ====}
 Constructor TDisplayKalk.Init(R: TRect);
  begin
   TView.Init(R);
   DspRsl:=VyslStr;
  end; {TDisplayKalk.Init}

 Procedure TDisplayKalk.DrawView;
  begin
   DspRsl:=VyslStr;
   TView.DrawView;
  end;

 Procedure TDisplayKalk.Draw;
  var  Color: Byte;  I:  Integer;  B: TDrawBuffer;
  begin
   TView.Draw;
   Color := GetColor(1);
   I := Size.X - Length(DspRsl) - 2;
   MoveChar(B,#32,Color,Size.X); {Display napl mezerami}
   MoveStr(B[I+2], DspRsl, Color);    {Souet do bufferu}
   WriteBuf(0, 0, Size.X, 1, B);{Zobraz souet - display}
  end; {TDisplayKalk.Draw}

 {==== TKalkulator Methods ====}
 Constructor TKalkulator.Init;
  var    R: TRect;
  begin
   R.Assign(0,3,22,15);
   TDialog.Init(R,'');
   Options:=Options or ofCenterX; {Kalk. centruj v ose X}
  end; {TKalkulator.Init}

 Procedure TKalkulator.Secti;
  const ErrVal = 'Neppustn vstupn hodnota';
  var   VyslTmp, Code: Integer;
  begin
   With KalkData do begin
    Dsp1^.GetData(Cis1);          {Zskn prvnho sla}
    Dsp2^.GetData(Cis2);          {Zskn druhho sla}
    Val(Cis1,VyslTmp,Code);     {Pevod etzce na slo}
    If Code = 0 then Vysl:=VyslTmp
    else MessageBox(#3+ErrVal, Nil, mfError+mfOkButton);
    Val(Cis2,VyslTmp,Code);     {Pevod etzce na slo}
    If Code = 0 then Vysl:=Vysl+VyslTmp
    else MessageBox(#3+ErrVal, Nil, mfError+mfOkButton);
    Str(Vysl:9,VyslStr);        {Pevod sla na etzec}
    PDisplay^.SetData(VyslStr); {Pedej vs. do displaye}
    PDisplay^.DrawView;               {Pekresli display}
    VyslStr:=KalkReady; {Pro ppad inicial. dal kalk.}
    SelectNext(False);    {Pesun kursoru na 1. stanec}
   end; {with}
  end; {TKalkulator.Secti}

 Procedure TKalkulator.HandleEvent(var Event: TEvent);
  begin
   TDialog.HandleEvent(Event);
   if Event.What = evBroadcast then
   begin
    case Event.Command of
     cmSecti: Secti;                      {Prove souet}
    else
      Exit;
    end; {case}                   {Udlost byla oetena}
    ClearEvent(Event);
   end;
  end; {TKalkulator.HandleEvent}
 {==== TAbout Methods ====}
 Constructor TAbout.Init;
  var R: TRect;
  begin
   R.Assign(4,15,75,21);
   TWindow.Init(R,'',WnNoNumber);
   AboutViewer:=New(PAboutViewer, Init(R,nil,nil));
   Insert(AboutViewer);  {Vlo prohlie do "okna"}
  end; {TAbout.Init}

 Constructor TAboutViewer.Init
  (var R:TRect; AHSc,AVSc:PScrollBar);
  begin
   R.Assign(0,0,75,7);
   TScroller.Init(R,nil,nil);
   {GrowMode:=gfGrowHiX + gfGrowHiY;}
  end; {TAboutViewer.Init}

 Procedure TAboutViewer.Draw;     {Pekresl "InfoPanel"}
  var
   B: TDrawBuffer;
   Color, Y: Byte;
  begin
   Color:=GetColor(2);
   For Y:=0 to Size.Y-1 do begin
    MoveChar(B,' ',Color,Size.X);
    WriteLine(0,Y,Size.X,1,B);
   end;
   MoveStr(B,'',Color);
   WriteLine(20,0,Size.X,1,B);
   MoveStr(B,' Turbo Vision  (D E M O) ',Color);
   WriteLine(20,1,Size.X,1,B);
   MoveStr(B,'',Color);
   WriteLine(20,2,Size.X,1,B);
   MoveStr(B,' Copyright (c) MAVIT,  Vit Malecek, Lidick'
   + 'a 33, 795 01 Rymarov ',Color);
   WriteLine(4,4,Size.X,1,B);
  end; {TAbout.Draw}

 {===== TMemory methods =====}
 Constructor TMemory.Init(var R: TRect);
  begin
  TView.Init(R);
  UpDown:=True; MemorySpace := '';
 end; {TMemory.Init}

 Procedure TMemory.Draw;
  var  B: TDrawBuffer;  C: Byte;
  begin
   C := GetColor(2);
   MoveChar(B, #219, C, Size.X);
   MoveStr(B, MemorySpace, C);
   WriteLine(0, 0, Size.X, 1, B);
  end; {TMemory.Draw}

 Function TMemory.FormatMemorySpace(MSpace: Real):String;
  const Up = #30;       Down = #31;
  var   PomMS: String;  OldLen, J: Byte;
  begin
   FillChar(PomMS, SizeOf(PomMS), #32);
   Str(MSpace:6:0,PomMS);
   While PomMS[1]=' 'do begin {Odsta levostrann mezery}
    OldLen:=Length(PomMS);
    For J:=1 to OldLen do
    PomMS[J]:=PomMS[J+1];
    PomMS[0]:=Chr(OldLen-1);
   end;
   UpDown:=not UpDown;
   If UpDown then FormatMemorySpace:='Free '+Up+PomMS+Mz4
   else FormatMemorySpace:='Free '+Down+PomMS+Mz4;
   Delay(300);
  end; {TMemory.FormatMemorySpace}

 Function TMemory.Update: LongInt;
  var  R: Registers;   FrMem: LongInt;
  begin
   R.AH:=72;                               {Pidl pam}
   R.BX:=$FFFF;   {Poadovan velikost pragraf * 16byt}
   MsDos(R);
   FrMem:=R.BX;            {Skuten pidleno paragraf}
   MemorySpace:=FormatMemorySpace(FrMem*16);
   UpDate:=FrMem;
   DrawView;
  end; {TMemory.Update}

 {===== TKalkApp methods =====}
 Constructor TKalkApp.Init;
  var  R: TRect;
  begin
   TApplication.Init;
   GetExtent(R);
   R.A.X:=R.B.X-12;
   R.B.Y:=R.A.Y+1;
   PMem:=New(PMemory,Init(R));
   Insert(PMem);
   PAb:=Nil;
   AboutOn;
  end; {TKalkApp.Init}

 Procedure TKalkApp.AboutOn;
  var
   R: TRect;  Color: Byte;
  begin
   If PAb=Nil then begin
    Color:=GetColor(1);
    PAb:=New(PAbout, Init);
    Desktop^.Insert(PAb);
    PAb^.DrawView;
   end;
  end; {TKalkApp.AboutOn}

 Procedure TKalkApp.AboutOff;
  begin
   If PAb <> Nil then begin
    Dispose(PAb,Done);
    PAb:=Nil;
    DeskTop^.DrawView;
   end;
  end; {TKalkApp.AboutOff}

 Procedure TKalkApp.Kalk;
  var  P:      PView;  PKalk:    PKalkulator;
       Result: Word;   KalkData: TKalkData;    R:TRect;
  begin
   KalkData.Cis1:='0';
   KalkData.Cis2:='0';
   PKalk:=New(PKalkulator, Init);
   If ValidView(PKalk) <> nil then begin
    PKalk^.SetData(KalkData);
    with PKalk^ do begin  {Vkld. dl. obj. TKalkulator}
     R.Assign(6,9,16,11);
     Insert(New(PButton,Init(R,'~S~eti',cmSecti,
            bfDefault+bfBroadcast)));
     R.Assign(13,4,18,5);
     Dsp1:=New(PInputLine,Init(R,3));
     Insert(Dsp1);
     R.Assign(2,4,12,5);
     Insert(New(PLabel,Init(R,'1. slo',P)));
     R.Assign(13,6,18,7);
     Dsp2:=New(PInputLine,Init(R,3));
     Insert(Dsp2);
     R.Assign(2,6,12,7);
     Insert(New(PLabel,Init(R,'2. slo',P)));
     R.Assign(2,2,20,3);
     PDisplay:=New(PDisplayKalk, Init(R));
     PDisplay^.Options:=PDisplay^.Options or ofFramed;
     Insert(PDisplay);      {Okolo displaye rmeek ^   }
     SelectNext(False);SelectNext(False);{Kurs. na 1.s.}
    end; {with}
    Desktop^.Insert(PKalk);
    PKalk^.SetData(KalkData);               {Pedn dat}
   end;
  end; {TKalkApp.Kalk}

 Procedure TKalkApp.Idle;
  begin
   TApplication.Idle;
   PMem^.Update;                  {Zjitn voln pamti}
  end; {TKalkApp.Idle}

 Procedure TKalkApp.InitMenuBar;
  var  R: TRect;
  begin
   GetExtent(R);  R.B.Y := R.A.Y + 1;
   MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu(#240, hcN, NewMenu(
     NewItem('Info ~O~n','F9',kbF9, cmAboutOn,hcN,
     NewItem('Info O~f~f','AltF9',kbAltF9,cmAboutOff,hcN,
     NewLine(
     NewItem('~K~onec', 'Alt-K', kbAltK, cmQuit, hcN,
    nil))))),
    NewSubMenu('K~a~lkulacka', hcN, NewMenu(
     NewItem('~O~n','F3',kbF3, cmKalk,hcN,
     NewItem('O~f~f','AltF3', kbAltF3, cmClose, hcN,
     NewItem('~P~osuv','CtrlF5', kbCtrlF5, cmResize,hcN,
     NewItem('~D~alsi', 'F6', kbF6, cmNext, hcN,
     NewItem('P~r~edch.','ShiftF6',kbShiftF6,cmPrev,hcN,
    nil)))))), nil)))));
  end; {TKalkApp.InitMenuBAr}

 Procedure TKalkApp.InitStatusLine;
  {Definice stavovho dku}
  var  R: TRect;
  begin
   GetExtent(R);  R.A.Y := R.B.Y - 1;
   StatusLine := New(PStatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      NewStatusKey('~AltK~_Konec', kbAltK, cmQuit,
      NewStatusKey('~F3~_On', kbF3, cmKalk,
      NewStatusKey('~AltF3~_Off', kbAltF3, cmClose,
      NewStatusKey('~F10~_Menu', kbF10, cmMenu, nil)))),
   nil)));
  end; {TKalkApp.InitStatusLine}

 Procedure TKalkApp.HandleEvent(var Event: TEvent);
  begin
   TApplication.HandleEvent(Event);
   if Event.What = evCommand then
   begin
    case Event.Command of
      cmKalk:     Kalk;
      cmAboutOn:  AboutOn;
      cmAboutOff: AboutOff;
    else
      Exit;
    end; {case}
    ClearEvent(Event);            {Udlost byla oetena}
   end;
  end; {TKalkApp.HandleEvent}

var    KalkApp: TKalkApp;
begin  { MAIN }
 VyslStr:=KalkReady;
 KalkApp.Init;
 KalkApp.Run;
 KalkApp.Done;
end.
