Unit Scit_Un;
 { Definuje objekty "kalkulaka". Objekty i metody jsou statick.          }
 { Ve vslednm soutu bude vdy vypsn etzec "pedek vech kalkulaek", }
 { protoe se vdy vol metoda Secti pedka a tm je TKalkSecti.           }
 {-------------------------------------------------------------------------}
 Interface
 type            {deklarace td}
  TKalk = object
   TypKalkul:    String;
   Num1S, Num2S: String;
   Num1, Num2: Integer;
   Procedure Init;
   Procedure ErrorAndHalt;
   Procedure GetNums;
   Function  Secti: Integer;
   Procedure WriteResult;
  end; {TKalk}

  TKalkDec = object(TKalk)
   Procedure GetNums;
   Function  Secti: Integer;
  end; {TKalkHex}

  TKalkHex = object(TKalk)
   Procedure GetNums;
   Function  Secti: Integer;
   Function  TransHexDec(Inp: String): Integer;
  end; {TKalkHex}

 Implementation
 {===== TKalk methods =====}
 Procedure TKalk.Init;
  begin
  end; {TKalk.Init}

 Procedure TKalk.ErrorAndHalt;
  {Ukon program pi neplatnm vstupu!}
  begin
   Writeln('Chybny vstup !!!',#7);
   Halt(1);
  end; {TKalk.ErrorAndHalt}

 Procedure TKalk.GetNums;
  {Sejmut sel z klvesnice}
  begin
  end; {TKalk.GetNums}

 Function TKalk.Secti: Integer;
  {Sete sejmut sla a "nastav" typ kalkulaky}
  begin
   TypKalkul:='Predek vsech kalkulacek';
   Write('(',TypKalkul,'): ',Num1S,'+',Num2S,' =');
   Secti:=Num1+Num2;
  end; {TKalk.Secti}

 Procedure TKalk.WriteResult;
  {Zobraz vsledn souet}
  begin
   Writeln('Soucet ',Secti:7);
  end; {TKalk.WriteResult}

 {===== TKalkDec methods =====}
 Procedure TKalkDec.GetNums;
  var
   Code: Integer;
  begin
   Write('Piste 1. cislo: ');
   Readln(Num1S);
   Val(Num1S,Num1,Code);
   If Code<>0 then ErrorAndHalt;
   Write('Piste 2. cislo: ');
   Readln(Num2S);
   Val(Num2S,Num2,Code);
   If Code<>0 then ErrorAndHalt;
  end; {TKalkDec.GetNums}

 Function TKalkDec.Secti: Integer;
  begin
   TypKalkul:='Dekadicka kalkulacka';
   Write('(',TypKalkul,'): ',Num1S,'+',Num2S,' =');
   Secti:=Num1+Num2;
  end; {TKalkDec.Secti}

 {===== TKalkHex methods =====}
 Procedure TKalkHex.GetNums;
  var
   Ckl: Byte;
  begin
   Write('Piste 1. cislo: ');
   Readln(Num1S);
   For Ckl:=1 to Length(Num1S) do
   If not(UpCase(Num1S[Ckl]) in ['0'..'F']) then ErrorAndHalt;
   Write('Piste 2. cislo: ');
   Readln(Num2S);
   For Ckl:=1 to Length(Num2S) do
   If not(UpCase(Num2S[Ckl]) in ['0'..'F']) then ErrorAndHalt;
  end; {TKalkHex.GetNums}

 Function TKalkHex.Secti: Integer;
  begin
   TypKalkul:='Hexa kalkulacka';
   Write('(',TypKalkul,'): ',Num1S,'+',Num2S,' =');
   Secti:=Num1+Num2;
  end; {TKalkHex.Secti}

 Function TKalkHex.TransHexDec;
  {Prevod retezce do dekadicke soustavy}
  var
   A,I : integer;
  begin
   A:=0;
   For I:=1 to Length(Inp) do Inp[I]:=UpCase(Inp[I]);
   For I:=1 to Length(Inp) do begin
    A:=A shl 4;
    If Inp[I]>='A' then A:=A + Ord(Inp[I])-55
    else A:=A + Ord(Inp[I]) - 48;
   end; {for}
   TransHexDec:=A;
  end; {TKalkHex.TransHexDec}

 end.
