Program Vyroci;
 {Program te databzov soubor PERSON.DTA vytvoen databz FileExpres.}
 {Struktura databz. soub. PERSON.DTA je ve File Expr. definovna takto: }
 { -field name-   -type-    -length-    -format-    -index length-       }
 { 1 Titul          C          5         Character         0             }
 { 2 Jmeno          C          10        Character         2             }
 { 3 Prijm          C          15        Character         2             }
 { 4 Datum          D          8         mm-dd-yy          2             }
 { 5 Dny            N          2         ##                0             }
 { 6 Text           C          40        Character         2             }
 {-----------------------------------------------------------------------}
 {Pedpokldme, e nebudeme chtt upozornit vce ne 1 msc dopedu.   }
 {Pro jednoduchost nebereme v vahu rzn poet dn v msci.            }
 {V autoexec.bat by bylo vhodn testovat ErrorLevel za elem oven, e}
 {databze byla opravdu tena.                                           }
 {-----------------------------------------------------------------------}
 {Zdrojov text zdarma nahraji na zaslanou disketu, zalete-li t znmku}
 {v hodnot 7,-Ks.   Ing. Vt Maleek, Obrnc mru 9, 796 01 Prostjov.}
 {}
 uses Dos, Crt;
 type
  THdr = record        {Deklarace struktury databze v TP}
   Titul:  String[ 5]; {Akademick titul                 }
   Jmeno:  String[10]; {Jmno                            }
   Prijm:  String[15]; {Pijmen                         }
   M,D,R:  String[ 2]; {Msc, Den, Rok z data           }
   Dny:    String[ 2]; {Kolik dn ped datem             }
   Text:   String[40]; {Doprovodn text                  }
   {----------- Nen soust hlaviky databze ----------}
   MB, DB, RB: Byte;   {M,D,R  z  THdr peveden  na slo}
   DnyB:       Byte;   {Dny pevedeny na slo           }
  end; {THdr}
 var
  FNdbf: PathStr;         Fdbf: Text;  Hdr:  THdr;
  _R, _M, _D, _DT: Word;  Emp:  Char;  Code: Integer;
  _MS, _DS:  String[2];   {Pevod _M, _D  na etzec     }
  Min, Max:  String[4];   {Meze asovho obdob          }
  _MS_DS:    String[4];   {_MS+_DS                       }

 Procedure WriteHelp;     {Vpis mal npovdy           }
  begin
   Writeln('Jako parametr uvete nzev datab. soub.:');
   Writeln('nap: Cti_Fex Person.DTA');
   Halt(1);
  end; {WriteHelp}

 Function TestF(FN: PathStr): Integer;    {Vrac IOResult}
  var  F: File; IOR: Integer;
  begin
   Assign(F,FN);
   {$I-} Reset(F,1); {$I+}
   IOR:=IOResult;
   If IOR = 0 then Close(F);
   TestF:=IOR;
  end; {TestF}

 Procedure GetParams;     {Zsk nzev datab. souboru FEx}
  begin
   If ParamCount <> 0 then begin
    FNdbf := ParamStr(1);
    Assign(Fdbf,FNdbf);
    If TestF(FNdbf) = 0 then Reset(Fdbf);
   end
   else WriteHelp;
  end; {GetParams}

 Procedure VyznamnyZazn;      {Vpis zznamu, je-li teba}
  var DP, MP, RP: String[2];
  begin
   With Hdr do begin
    DP:=D; MP:=M; RP:=R;
    Max:=M+D;
    If (DB-DnyB) >= 0 then DB:=DB-DnyB
    else begin
     DB:=DB-DnyB+30;
     MB:=MB-1;
    end; {else}
    Str(MB:2,M); Str(DB:2,D);
    If MB < 10 then M[1]:='0';
    If DB < 10 then D[1]:='0';
    Min:=M+D;
    If (_MS_DS>=Min)and(_MS_DS<=Max) then
    Writeln(Jmeno,Prijm,DP,'-',MP,'-',RP,' ',Text);
   end; {with}
  end; {VyznamnyZazn}

 begin {MAIN}
  GetParams;
  Writeln('***** Vpis aktulnch vro ******');
  GetDate(_R, _M, _D, _DT);
  Str(_M:2,_MS); Str(_D:2,_DS);
  If _M < 10 then _MS[1]:='0';
  If _D < 10 then _DS[1]:='0';
  _MS_DS:=_MS+_DS;
  While not eof(Fdbf) do begin
   With Hdr do begin
    Readln(Fdbf,Titul,Jmeno,Prijm,M,Emp,D,Emp,R,Dny,Text);
    Val(M,MB,Code); Val(D,DB,Code);
    Val(R,RB,Code); Val(Dny,DnyB,Code);
    VyznamnyZazn;
   end; {with}
  end; {while}
  Close(Fdbf);
  Write('Stiskni klavesu ...'); Emp:=Readkey;
 end.
