program cerv;
  uses crt,dos;
const sipkavlevo= 331; sipkavpravo= 333; sipkanahoru= 328; sipkadolu= 336;
      konec= 27;                { ESCAPE }
      vlevo= sipkavlevo; vpravo= sipkavpravo;
      nahoru= sipkanahoru; dolu= sipkadolu;
      telo= '';                { ALT 219 }
      zradlo= '.'; jed= '+';
      ramecek= '';             { ALT 178 }
      pocetzradel= 50; pocetjedu= 20;
      maxpocetrekordu= 10;
type uclanek= ^clanek;
     clanek= record x1,y1:byte; next: uclanek; end;
     videoram= array[1..25] of array[1..80] of integer;
var videoptr: ^videoram;
    i,j,delka,cekej,rychlost,kl,novakl,poslrekord: integer;
    x,y: byte;
    f: text;
    ch: char;
    rekord: boolean;
    konecek,hlava: uclanek;
    jmeno,strdelka: string;
    rek: array[1..maxpocetrekordu] of record delka:integer;
                                             jmeno: string[20]; end;
function klavesa: integer;
var ch: char;
begin
  ch:= readkey;
  if ch= #0 then klavesa:= 256+ integer(readkey)
    else klavesa:= integer(ch);
end; {klavesa}

function platnaklavesa(kl:integer): boolean;
begin
  platnaklavesa:= (kl=vlevo) or (kl=vpravo) or (kl=nahoru) or (kl=dolu)
                  or (kl=konec);
end; {platnaklavesa}

procedure zprava(s:string);
var kl: integer;
begin
  clrscr; gotoxy(10,12); writeln(s);
  gotoxy(10,14); writeln('Stiskni libovolnou klavesu');
  kl:= klavesa;
end; {zprava}

function adrvram: pointer;
var reg: registers;
begin
  intr($11,reg);
  if (reg.al and $30)= $30 then  adrvram:= ptr($B000,0)
    else adrvram:= ptr($B800,0);
end; {adrvram}

function znakxy(x,y:byte): char;
begin
  znakxy:= chr(lo(videoptr^[y,x]));
end; {znakxy}

procedure pisznaky(ch:char; pocet:integer);
var i,x,y: integer;
begin
  i:= 0;
  while i<= pocet do begin
    x:= random(78); y:= random(22);
    if znakxy(x+1,y+1)= ' ' then begin
      gotoxy(x+1,y+1); write(ch); inc(i); end;
    end;
end; {pisznaky}

procedure novyclanek(x,y:byte);
var ucl: uclanek;
begin
  gotoxy(x,y); write(telo);
  new(ucl);
  with ucl^ do begin
    x1:= x; y1:= y; next:= nil; end;
  if hlava<> nil then hlava^.next:= ucl;
  hlava:= ucl;
end; {novyclanek}

procedure smazkonecek;
var ucl: uclanek;
begin
  with konecek^ do begin
    gotoxy(x1,y1); write(' '); end;
  ucl:= konecek; konecek:= konecek^.next; dispose(ucl);
end; {smazkonecek}

begin                                      {***** hlavni program *****}
{$i-}
{$r-}
  rychlost:= 0;
  repeat
    write('Na jakou rychlost si troufas ? (1 - 5): '); readln(rychlost);
  until (ioresult=0) and (rychlost in [1..5]);
  cekej:= 200+ 50*(5-rychlost);
  clrscr; videoptr:= adrvram;
  for i:= 1 to 24 do begin
    gotoxy(1,i);  write(ramecek); gotoxy(80,i); write(ramecek);
    if i in [1,24] then
      for j:= 2 to 79 do begin
        gotoxy(j,i); write(ramecek); end;
    end;
  randomize;
  pisznaky(zradlo,pocetzradel); pisznaky(jed,pocetjedu);
  repeat
    x:= random(78)+ 1; y:= random(22)+ 1;
  until znakxy(x,y)= ' ';
  hlava:= nil;
  novyclanek(x,y); konecek:= hlava; delka:= 1;
  repeat
    kl:= klavesa;
  until platnaklavesa(kl);
  repeat
    if keypressed then begin
      novakl:= klavesa;
      if platnaklavesa(novakl) then kl:= novakl;
      end;
    case kl of
      vlevo: dec(x);
      vpravo: inc(x);
      nahoru: dec(y);
      dolu: inc(y);
      end;
    if (kl<>konec) then begin
      case znakxy(x,y) of
        ramecek: begin zprava('Narazil jsem do zdi'); kl:= konec; end;
        telo:    begin zprava('Zakousl jsem sam sebe'); kl:= konec; end;
        zradlo:  begin inc(delka); novyclanek(x,y);
                  if delka mod 10 = 0 then pisznaky(zradlo,10); end;
        jed:     begin zprava('Nazral jsem se jedu'); kl:= konec; end;
        else begin novyclanek(x,y); smazkonecek; end;
        end;
      gotoxy(40,25); write(delka);
      delay(cekej);
      end;
  until kl= konec;
  str(delka,strdelka);
  zprava('Dosahl(a) jsi '+ strdelka + ' bodu');
  assign(f,'cerv.log');
  reset(f);
  if ioresult<>0 then begin
    rewrite(f);
    if ioresult<>0 then begin
      zprava('Na disku neni misto pro knihu rekordu'); halt; end;
    end;
  reset(f);
  i:= 0;
  while not eof(f) do begin
    inc(i); readln(f,rek[i].delka,ch,rek[i].jmeno); end;
  poslrekord:= i;
  if poslrekord< maxpocetrekordu then
      rekord:= true
    else rekord:= delka> rek[maxpocetrekordu].delka;
  if rekord then begin
    writeln;
    repeat
      gotoxy(10,14); clreol;
      write('Zadej svoje jmeno: '); readln(jmeno); jmeno:= copy(jmeno,1,20);
    until jmeno<> '';
    j:= 1;
    while (rek[j].delka>delka) and (j<=poslrekord) do inc(j);
    if poslrekord< maxpocetrekordu then inc(poslrekord);
    i:= poslrekord;
    while i>j do begin
      rek[i]:= rek[i-1]; dec(i); end;
    rek[j].delka:= delka; rek[j].jmeno:= jmeno; end;
  rewrite(f);
  i:= 1; clrscr;
  writeln('    P r e h l e d   r e k o r d u'); writeln;
  while i<= poslrekord do begin
    writeln(rek[i].jmeno:20,rek[i].delka:5);
    writeln(f,rek[i].delka,' ',rek[i].jmeno); inc(i); end;
  close(f);
end.