    Unit CS;
     {$F+,O+,L+,D+}
     { Unit, kter slou k nataen fontu z externho }
     { diskovho souboru  do grafickho adaptru.  Tak }
     { lze zajistit zapnn a vypnn etiny pro mo-}
     { tor.  Jde  tedy o driver  monitoru. Ke vkldn }
     { eskch znak je teba si opatit driver klves.}
     {=================================================}
     {Ing Vt Maleek, Obrnc mru 9, Prostjov 796 01}
     {-------------------------------------------------}
     Interface
      Procedure LoadFont(FileFnt: String; PL: Byte);

     Implementation
     uses Dos;
     const
      Rng = 4096;  {16 * 256 = 4096}
     var
      FIn: File;
      R: Registers;
      VgaFont: Array [0..Rng-1] of Byte;
      Count: 0..Rng;

     Function TestFile(FName: PathStr): Byte;
      var
       F:   File;
       IOR: Integer;
      begin
       Assign(F,FName);
       {$I-} Reset(F); {$I+}
       IOR := IOResult;
       If IOR = 0 then Close(F);
       TestFile:=IOR;
      end; {TestFile}

     Procedure LoadFont(FileFnt: String; PL: Byte);
      { Zajisti zaveden fontu uloenho v souboru FileFnt.}
      { PL udv poet linek znakovho rastru. PL krt 256 }
      { mus dt dlku souboru FileFnt v bytech            }
      begin
       If TestFile(FileFnt)<>0 then Exit;
       Assign(FIn, FileFnt);
       Reset(FIn,1);
       While not Eof(FIn) do begin   {Nati font do bufferu}
        BlockRead(FIn, VgaFont, Rng, Count);
       end;
       Close(FIn);
       R.BH:=PL;               {Poet linek ve znak. rastru}
       R.ES:=Seg(VGAFont[0]);  {Segm. adr. pole dat s fonty}
       R.BP:=Ofs(VGAFont[0]);  {Ofs.  adr. pole dat s fonty}
       R.AH:=$11;              {Funkce 11H: genertor znak}
       R.AL:=$00;              {Podfunk. 0H: nataen fontu}
       R.BL:=0;                {slo sady znak  pro nhr.}
       R.CX:=256;              {Poet  nahrazovanch  znak}
       R.DX:=0;                          {Kd prvnho znaku}
       Intr($10,R);            {Zave font z buffe. VGAFont}
      end; {LoadFont}

     end.
