unit LINE;
{ Copyright (C) Radek Huln }
{ Srpen 1993                }
interface

{***************************************************************************}
procedure TPoint(S,R,_Na,_Pr,_Do,_Le,Atr,Typ :Byte);
procedure TLine (S1,R1,S2,R2,Atr,Typ :Byte);
procedure TBox  (S1,R1,S2,R2,Atr,Typ :Byte; VymazatObsah :Boolean);
function  VideoMode: Word;
type ObrazovyBod = record
		     Znak : Char;
		     Attr : byte;
		 end;
     ScreenArray = array[1..25,1..80] of ObrazovyBod;
var  Scr    : ^ScreenArray;
     ScrSeg : Word;
const  NormLine = 1;
       BoldLine = 2;
{***************************************************************************}

implementation
uses Dos;

const RetezZnaku : String[40] = 'ٳŸ˾';

function VideoMode;
var R:Registers;
begin
  R.AH:=15;
  Intr($10,R);
  case R.AL of
    0..6  : VideoMode:=$B800;
    7..10 : VideoMode:=$B000;
    11..16: VideoMode:=$A000;
  end;
end;

procedure TPoint(S,R:Byte; _Na,_Pr,_Do,_Le:Byte; Atr,Typ:byte);
type  ZnakTyp = Array[1..4] of Byte;
const Znaky : Array[1..40] of ZnakTyp = { vlastn rozpitvvac konstanty }
 ((0,0,1,1),(0,1,0,1),(0,1,1,0),(0,1,1,1),(1,0,0,1),(1,0,1,0),(1,0,1,1),
  (1,1,0,0),(1,1,0,1),(1,1,1,0),(1,1,1,1),(0,0,1,2),(0,0,2,1),(0,0,2,2),
  (0,2,0,2),(0,1,2,0),(0,2,1,0),(0,2,2,0),(0,1,2,1),(0,2,1,2),(0,2,2,2),
  (1,0,0,2),(2,0,0,1),(2,0,0,2),(2,0,2,0),(1,0,1,2),(2,0,2,1),(2,0,2,2),
  (1,2,0,0),(2,1,0,0),(2,2,0,0),(2,1,0,1),(1,2,0,2),(2,2,0,2),(1,2,1,0),
  (2,1,2,0),(2,2,2,0),(1,2,1,2),(2,1,2,1),(2,2,2,2));
var i:byte; POM:ZnakTyp;

    procedure ZakladniTvar;
    begin
      POM[1]:=_Na; POM[2]:=_Pr; POM[3]:=_Do; POM[4]:=_Le;
    end;

    procedure Soused(R,S,_pom,_soused:byte);
    begin
      if (POM[_pom]<>0) or (R<1) or (R>25) or (S<1) or (S>25) then exit;
      i:=Pos(Scr^[R,S].Znak,RetezZnaku);
      if (i>0) AND (Znaky[i][_soused]>0) then POM[_pom]:=Typ;
    end;

begin
  i:=Pos(Scr^[R,S].Znak,RetezZnaku);
  if i<>0 then begin
    POM:=Znaky[i]; { test zda nco pekresluji na aktuln pozici }
    i:=Pos(Scr^[R,S].Znak,RetezZnaku);
    if POM[1]=0 then POM[1]:=_Na;
    if POM[2]=0 then POM[2]:=_Pr;
    if POM[3]=0 then POM[3]:=_Do;
    if POM[4]=0 then POM[4]:=_Le;
  end else
    ZakladniTvar;
  Soused(R-1,S,1,3); { test zda soused nahoe m rku dole }
  Soused(R,S+1,2,4); { test zda soused vpravo m rku vlevo }
  Soused(R+1,S,3,1); { test zda soused dole m rku nahoe }
  Soused(R,S-1,4,2); { test zda soused vlevo m rku vpravo }
  repeat
    for i:=1 to 40 do
      if LongInt((@POM)^)=LongInt((@Znaky[i])^) then
      begin
	Scr^[R,S].Znak:=RetezZnaku[i]; { byl nalezen odpovdajc znak }
	if Atr<>0 then Scr^[R,S].Attr:=Atr;
	exit;
      end;
    ZakladniTvar; { znak nebyl nalezen, bude pouit zkladn tvar }
  until false;
end;

procedure TLine;
var i:byte;
begin
 if S1=S2 then for i:=R1 to R2 do TPoint(S1,i,Typ,0,Typ,0,Atr,Typ);
 if R1=R2 then for i:=S1 to S2 do TPoint(i,R1,0,Typ,0,Typ,Atr,Typ);
end;

procedure TBox;
var i,j:byte;
begin
  TLine(S1+1,R1,S2-1,R1,Atr,Typ);    { nakreslen stran obdelnku }
  TLine(S2,R1+1,S2,R2-1,Atr,Typ);
  TLine(S1+1,R2,S2-1,R2,Atr,Typ);
  TLine(S1,R1+1,S1,R2-1,Atr,Typ);
  TPoint(S1,R1,0,Typ,Typ,0,Atr,Typ); { a jeho ty roh }
  TPoint(S2,R1,0,0,Typ,Typ,Atr,Typ);
  TPoint(S2,R2,Typ,0,0,Typ,Atr,Typ);
  TPoint(S1,R2,Typ,Typ,0,0,Atr,Typ);
  if VymazatObsah then
    for i:=S1+1 to S2-1 do for j:=R1+1 to R2-1 do
    begin
      if POS(Scr^[j,i].Znak,RetezZnaku)=0 then Scr^[j,i].Znak:=#32;
      if Atr<>0 then Scr^[j,i].Attr:=Atr;
    end;
end;

begin
  ScrSeg:=VideoMode;
  Scr:=Ptr(ScrSeg,0);
end.