{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+}
unit MySort;                                       { MYSORT.PAS }

interface

uses Overlay;

type TCompFunc1 = function ( i    : word ): boolean;
     TCompFunc2 = function ( i, j : word ): boolean;
     TUserInit  = procedure( i    : word );
     TMoveProc  = procedure( i, j : word );

procedure QuickSort(     Number       : longint;
                     var NumberMove   : longint;
                         FAR_Init     : TUserInit;
                         ResultComp1,
                         ResultComp2  : TCompFunc1;
                         ResultComp3  : TCompFunc2;
                         MoveGo       : TMoveProc );

implementation

function TestNumber( n : longint ): boolean;
begin
  TestNumber:=((n > 1) and ( n <= 65535))
end;

procedure QuickSort;
var i,j : word;

  procedure NextIndex;
  begin
    Inc(i);
    Dec(j)
  end;

  procedure SortGo( l,r : word );
  begin
    i:=l;
    j:=r;
    { Bezpen odloenie hodnoty do pouvateskho programu pre
      porovnvanie v om }
    FAR_Init((l div 2)+(r div 2));
    repeat
      while ResultComp1(i) do                  { [i] < FAR_Init }
        Inc(i);
      while ResultComp2(j) do                 { [j] >= FAR_Init }
        Dec(j);
      if i = j then
        NextIndex
      else
        if i < j then
        begin
          if not ResultComp3(i,j) then              { [i] = [j] }
          begin
            MoveGo(i,j);                        { swap [i], [j] }
            Inc(NumberMove)
          end;
          NextIndex
        end
    until i > j;
    if l < j then
      SortGo(l,j);
    if i < r then
      SortGo(i,r)
  end;

begin
  NumberMove:=0;
  if not TestNumber(Number) then
    Exit;
  SortGo(1,Number)
end;

end.
