Program My_DCOPY;
{--------------------------------------------------------------------}
{Provd diskcopy diskety - 360KB (5.25": 40stop, 9 sektor/stopa) po}
{sektorech. Pi kadm ten/zpisu sektoru je  v R.AH vrcen chybov}
{kd operace. Pi nenulovm R.AH  lze operaci ignorovat nebo opakovat}
{Koprovn  probh pes dynamickou promnnou  SektVar. Pamatujte na}
{dostatenou velikost heapu!                                         }
{Program spuste takto: My_DCopy ZdrojovyDisk CilovyDisk neb My_DCopy}
{--------------------------------------------------------------------}

  {$M 1024, 380000, 380000}                  {Alokace potrebne pameti}
  {$D-,L-,S-,R-,B-}
  uses
   Crt, Dos;
  type
   PSekt = ^TSekt;
   PDisk = ^TDisk;
   TSekt = array [1..512] of byte;
   TDisk = array [1..720] of PSekt;
  var
   Sekt: PSekt;         SektVar: TSekt;       Disk:    TDisk;
   FO:   text;          YN:      Char;        DiskS:   Byte;
   Ft:   0..39;         Sec:     0..9;        Hd:      0..1;
   R:    Registers;     DiskT:   Byte;        I,Index: Integer;

  Function Continue: boolean;
   {Vraci TRUE, po stisku klavesy <a> nebo <A>}
   begin
    writeln;
    write('Opakovat cteni/zapis ? [A/N]: ');
    YN:=readkey;      writeln(UpCase(YN));
    If UpCase(YN)='A' then Continue:=True
    else Continue:=False;
   end; {Continue}

  Procedure Cti(FlDisk,Ft,Se,Hd: byte);
   {Precte z disk. v mecha. FlDisk sektor Se na stope Ft z povrchu Hd}
   begin
    Sekt:=New(PSekt);
    Disk[I]:=Sekt;
    repeat
     write(FO,'Ctu stopu: ',ft:2,' sektor: ',se:1,' povrch: ',hd:1);
     r.ah:=2;           { Cislo podfunkce }
     r.al:=1;           { Kolik sektoru }
     r.ch:=ft;          { stopa  }
     r.cl:=se;          { sektor }
     r.dh:=hd;          { povrch }
     r.dl:=FlDisk;      { identifikace jednotky }
     r.es:=seg(Sekt^);  { segment adresy na kterou ukladat data }
     r.bx:=ofs(Sekt^);  { ofset   adresy na kterou ukladat data }
     intr($13,r);       { cti pozadovany sektor }
     write(FO,' ..... R.AH =',R.AH:2);
     writeln;
     If (R.AH<>0) and (R.AH<>6) then If not Continue then R.AH:=0;
    until R.AH = 0;
   end;   { End Of Cti }

  Procedure Pis(FlDisk,Ft,Se,Hd: byte);
   {Zapise na disk. v mech. FlDisk sektor Se na stope Ft z povrchu Hd}
   begin
    Sekt:=Disk[I];
    repeat
     write(FO,'Pisu stopu: ',ft:2,' sektor: ',se:1,' povrch: ',hd:1);
     r.ah:=3;            { Cislo podfunkce }
     r.al:=1;            { Kolik sektoru }
     r.ch:=ft;           { stopa  }
     r.cl:=se;           { sektor }
     r.dh:=hd;           { povrch }
     r.dl:=FlDisk;       { identifikace jednotky }
     r.es:=seg(Sekt^);   { segment adresy kde jsou ulozena data }
     r.bx:=ofs(Sekt^);   { ofset   adresy kde jsou ulozena data }
     intr($13,r);        { pis pozadovany sektor }
     write(FO,' ..... R.AH =',R.AH:2);
     writeln;
     If (R.AH<>0) and (R.AH<>6) then If not Continue then R.AH:=0;
    until R.AH = 0;
   end;   { End Of Pis }

  Procedure Help;
   begin
    writeln('Program spustte prikazem: My_DCopy ZdrojDisk CilDisk');
    Halt(1);
   end; {Help}

  Procedure GetParameters;
   {Precte parametry z prikazoveho radku.}
    var Parametr: String;  I: byte;
   begin
    If ParamCount < 2 then Help;
    Parametr:=ParamStr(1);
    For I:=1 to Length(Parametr) do Parametr[I]:=UpCase(Parametr[I]);
    If Parametr[1] in ['A','B'] then DiskS:=Ord(Parametr[1])-65
     else Help;
    Parametr:=ParamStr(2);
    For I:=1 to Length(Parametr) do Parametr[I]:=UpCase(Parametr[I]);
    If Parametr[1] in ['A','B'] then DiskT:=Ord(Parametr[1])-65
     else Help;
   end; {GetParameters}

  begin { MAIN}
   GetParameters;
   AssignCrt(FO);    { rychly vystup na obrazovku}
   rewrite(FO);
   ClrScr;
   Write(FO,'Vloz zdrojovou disketu .....'#7);
   Readln;
   Hd:=0;
   For I:=0 to 719 do begin
    If I>359 then begin Index:=I-360; Hd:=1; end else Index:=I;
    Ft := Index div 9;
    Sec:= (Index mod 9)+1;
    Cti(DiskS,Ft,Sec,Hd);
   end;
   Write(FO,'Vloz cilovou disketu .....'#7);
   Readln; Hd:=0;
   For I:=0 to 719 do begin
    If I>359 then begin Index:=I-360; Hd:=1; end else Index:=I;
    Ft := Index div 9;
    Sec:= (Index mod 9)+1;
    Pis(DiskT,Ft,Sec,Hd);
    Dispose(Sekt);
   end;
  end.
