@CT 0
@LM 1
@RM 60
@PL 62
@TB -----T-----T-----T-----T-----T-----T-----T-----T-----T-----T-----T-----T-----T-----T-----T-----T-----T-----T-----T-----T-----T-----T
@MT 0
@MB 2
@PO 14
@PN 2
@LH 6
    Program OKRAJ;
     { Nastav rmeek obrazovky do poadovan barvy }
     { uren parametrem zadanm z pkazov dky.  }
     { Peklada: Turbo Pascal 6.0                   }
     { Sputn programu nap C:\>OKRAJ 112 <ENTER>  }
     {-----------------------------------------------}
     { Vt Maleek, Obrnc mru 9, 796 01 Prostjov }
     {-----------------------------------------------}

     uses Dos;
     var  R: registers;
          C: byte;
          E: integer;

     Procedure Helpik;
      begin
       Writeln;
       Writeln('Spuste pkazem OKRAJ X <ENTER> ');
       Writeln('kde: X je slo z inter. <0..15>.');
       Writeln('0: ern       8: tmaved      ');
       Writeln('1: modr       9: svtlemodr    ');
       Writeln('2: zelen     10: svtlezelen   ');
       Writeln('3: tyrkysov  11: svtletyrkysov');
       Writeln('4: ervan    12: svtleerven  ');
       Writeln('5: fialov    13: svtlefialov  ');
       Writeln('6: hnd      14: lut          ');
       Writeln('7: svtleed 15: bl           ');
       Writeln;
       Writeln('H (jin znak):Help (npovda)    ');
      end;  {end of Helpik}

     begin  {MAIN}
      if ParamCount = 0 then
       C:=0
      else begin
       Val(ParamStr(1),C,E);
       If (E<>0) Or Not (C in [0..15]) Then begin
        Writeln('Chybn parametr'+Chr(7));
        Helpik;
        Halt(1);      {Pedn chybn argument, skoni}
       end;
      end; {else}
      C:=C+0*16;          {0*16: barva pozad - ern}
      R.AH:=$0B;
      R.BH:=$00;
      R.BL:=C;                          {barva okraje}
      Intr($10,R);                 {zm barvu okraje}
     end.
  



  ;--------- OKRAJ.ASM --------------------------------
  ;Program pro nastaven poadovan barvy rmeku obra-
  ;zovky (na kart VGA)
  ;P O Z O R !!!  Po linkovn prove pkaz:
  ;EXE2BIN OKRAJ.EXE OKRAJ.COM
  parametr   equ 5dh
  seg_main   segment byte public
             assume  cs:seg_main, ds:seg_main
             org 100h

  okraj      proc far
  start:
             mov si,parametr
             mov ah,[si]
             cmp ah,'!'        ;je poadovn zven jas?
             jz short highin   ;pokud ano, jdi na highin
             cmp ah,20h        ;nebyl pedn dn param.?
             jz short badpar   ;kdy nebyl, vypi helpk
  setokr:
             mov bl,ah         ;kd barvy rmeku
             mov bh,00h
             mov ah,0Bh        ;slo subfunkce
             int 10h           ;pebarvi rmeek
             jmp short cont    ;nastaveno, budeme konit
  badpar:
             mov dx,offset helpt
             mov ah,9          ;vypi etzec na obrazovku
             int 21h           ;vpis napovdy
  cont:
             mov ah,4ch
             int 21h            ;ukoni program
  helpt:     db 10,13,'Pi "okraj X", kde X je slo z'
             db ' intervalu 0 a 15.'
             db 10,10,13
             db '$'             ;definovn textu npovdy
  okraj      endp

  highin:
             mov si,parametr
             mov ah,[si+1]      ;byl !, vezmi znak za !
             sub ah,48          ;pevod znaku na slo
             add ah,8           ;zvy intenzitu barvy
             jmp short setokr   ;barva OK, nastavme rm.
  seg_main   ends
             end     start
