Program PrnScr;
 { Rezidentni program pro snimani  obrazovky do souboru }
 { po stisku klavesy Print Screen.                      }
 {======================================================}
 {*** Vt Maleek, Obrnc mru 9, 796 01 Prostjov. ***}
 { Program zdarma nahraji na zaslanou disketu, jestlie }
 { pilote znmku v hodnot 7,-K.                    }
 {------------------------------------------------------}
 {$M 1024,0,0}
 {$D-,L-,R-,E-,I-,N-,S-}          {Generuj minimln kd}

 uses Dos, Crt;
 const
  FName: PathStr='COPY_SCR.TXT';  {Implic. nzev souboru}
  EndOfScr = '        Konec obrazovky      ';
 var
  P: pointer;  F: text;

 Procedure HaltAfterKeep(ExitCode: Byte);
  { Dosud rezidentn program uvoln z pamti. }
  var
   R: registers;
  begin
   R.AH:=$49;
   R.ES:=PrefixSeg;
   MsDos(R);      {Uvolnn pamti psluejc programu}
   R.AH:=$4C;
   R.AL:=ExitCode;
   MsDos(R);                  {Explicit. ukon. programu}
   writeln('Prog. PRINT_SCR_TO_FILE z pamti odstrann');
  end; {HaltAfterKeep}

 Procedure SetPozKur(Sloup, Rad: Byte);
  { Umst kurzor na dek Rad a sloupec Sloup, a to na }
  { videostrnku slo nula.                            }
  var
   R: Registers;
  begin
   R.AH:=$02;                     {Nastav pozici kurzoru}
   R.BH:=$00;                     {Video strnka is.  0}
   R.DH:=Rad;                     {Nov  dkov  pozice}
   R.DL:=Sloup;                   {Nov  sloupc.  pozice}
   Intr($10,R);                            {Sluba VIDEO}
  end; {End Of: SetPozKur}

 Procedure PrtScr;
  { Procedura volan po stisku klvesy  <Print Screen>. }
  { Rutina ulo obrazovku  (textov reim) do souboru. }

  interrupt;

  var
   R: registers; C: char;
   I: 0..24;     J: 0..79;   {Md : 25 dk, 80 sloupc}
   OrgX,         OrgY: byte; {Poz.kurz. pi aktiv.PrtScr}
  begin
   (*- Piprav soubor pro zpis *)
   {$I-} Append(F); {$I+}  {Oteven soub. pro pidvn}
   If IOResult <> 0 then Rewrite(F);   {Zalo nov soub.}
   (*- Ulo si pozici kurzoru v dob stisku kl. Pr.Sc. *)
   R.AH:=$03;                     {Zjisti pozici kurzoru}
   R.BH:=$00;                       {slo video strnky}
   Intr($10,R);                            {Sluba VIDEO}
   OrgX:=R.DL;                      {Ulo sloupc. pozici}
   OrgY:=R.DH;                      {Ulo dkov. pozici}
   (*- Ulo obrazovku do souboru *)
   For I:=0 to 24 do begin       {Projdi vechny   dky}
    For J:=0 to 79 do begin      {Projdi vechny sloupce}
     SetPozKur(J,I);              {Nastav pozici kurzoru}
     R.AH:=$08;                   {ti znak na poz.kurz.}
     R.BL:=$00;                    {Video strnka s. 0}
     Intr($10,R);                          {Sluba VIDEO}
     Write(F,chr(R.AL));            {Zapi preten znak}
    end; {For J}
    Writeln(F);                   {Zapi oddlova dk}
   end; {For I}
   Writeln(F,EndOfScr,EndOfScr);  {Zapi oddl.obrazovky}
   Close(F);                        {Uzavi text. soubor}

   (*- Umsti kurzor na posledn dek *)
   SetPozKur(38,23);
   (*- Sejmut znaku z klvesnice *)
   Write('Odstranit program z pamti? [Ano/Ne=ENTER]: ');
   R.AH:=00;
   Intr($16,R);                {ten znaku z klvesnice}
   C:=chr(R.AL);               {Ulo si znak z klv.buf.}

   (*- Obnov pozici kurzoru *)
   SetPozKur(OrgX, OrgY);         {Nastav pozici kurzoru}

   (*- Vyhodnocen dotazu *)
   if C in ['a','A'] then begin
    SetIntVec($05,p);   {Obnov pesmrov. vektor peru.}
    SetIntVec($80,nil);
    HaltAfterKeep(0);          {Uvolni rezident z pamti}
   end;

  end; {PrtScr}

 begin {MAIN}
  If ParamCount=1 then FName:=ParamStr(1); {Nz. souboru}
  Assign(F,FName);
  GetIntVec($05,p);       {Pesmruj vektor peruen na}
  SetIntVec($80,p);       {novou obslunou rutinu PrtScr}
  SetIntVec($05,@PrtScr);

  Writeln('Instalovn rezidentn dotaz na Print Scre'+
  'en!'+#10,#13+'Ukldn obrazovek do souboru: ',FName);
  Keep(0);                   {Ukoni a zsta rezidentn}
 end.
