{  TIM0TEST.PAS - Test vzorkovani a cteni systemoveho casovace c.0
   (C) Ivan Dolezal  19. 8. 1994  }
program Tim0Test;
uses
   Crt;
label
   loopbreak;
var
   t, t0, t1, ti1, ti2, ticks0 : word;

   { Funkce vzorkuje systmov asova .0 a vrac jeho aktuln stav }
   function GetTimer : word;
   label
      j1, j2, j3;
   var
      t : word;
   begin
      asm
        mov  al,0;      { kd povelu pro vzorkovn systmovho asovae .0 }
        out  43h,al;    { vysln povelu na dic port }
        jmp  j1;
     j1:jmp  j2;        { zpodn pro reakci obvodu pi vysok rychlosti CPU }
     j2:in   al,40h;    { ten niho bajtu asovae .0 }
        mov  ah,al;
        jmp  j3;        { zpodn pro reakci obvodu pi vysok rychlosti CPU }
     j3:in   al,40h;    { ten vyho bajtu asovae .0 }
        xchg ah,al;     { prohozen bajt do sprvnho poad }
        mov  (t),ax;    { nvratov hodnota jen pes pomocnou promnnou }
      end;
   GetTimer := t;
   end;

begin
   writeln;
   writeln('--- TIM0TEST --- Test cteni systemoveho casovace c.0 ---');
   writeln;
   ti1 := 0;                      { znaka bezchybnho ten }
   ti2 := 0;                      { znaka bezchybnho ten }
   ticks0 := MemW[0:$046C] + 1;   { uloen pt hodnoty tae peruen }
      {  0:046C je ni slovo promnn BIOS
         - tae peruen IRQ 0 -> INT 08 od systmovho asovae .0 }
   repeat until ( MemW[0:$046C] = ticks0 ); { ek na peruen od as. .0 }
   t0 := gettimer;
   t1 := t0;                      { uchovn potenho stavu }
   Inc(ticks0);                   { pt hodnota tae peruen }
   repeat
      t := gettimer;              { te stav tae }
      if  MemW[0:$046C] = ticks0
        then goto loopbreak;      { ukonen smyky pi dalm peruen }
      if (t > t0) then            { nov hodnota > star pi dekrementaci ? }
        begin
           ti1 := t0; ti2 := t;   { uloen stav asovae ped a po podteen }
        end;
      t0 := t;                    { aktualizace star hodnoty }
   until false;
loopbreak:
   writeln( 'Stav citace po zacatku intervalu preruseni  : ', t1:5 );
   if ( ti1 <> ti2 )  then        { jestlie dolo k podteen }
      writeln('Chybny prechod nacitane hodnoty pres nulu   : ',
      ti1:5, ' -> ', ti2 );
   writeln( 'Stav citace pred koncem intervalu preruseni : ', t0:5 );
   writeln;
end.
