;ELEKTRONICKY ZAMEK NA KOD VE STROJOVEM KODU I8086
;  v.4.1  28.4.1993  na  Turbo ASSEMBLERu

;NAVESTI   PRIKAZ OPRANDY             KOMENTAR

           .MODEL SMALL
           .STACK 100
           .DATA                      ;DATOVY SEGMENT
DELRAD     EQU    70D                 ;BLOK PROGRAMOVYCH KONSTANT
DELUZV     EQU    5                   ;POCET ZN. V UZIVAT. HESLE
DELPRG     EQU    4                   ;POCET ZN. V HESLE PROGRAMATORA
OPRAV      EQU    2                   ;MAX. POCET CHYB
KLIC       EQU    5                   ;KLIC CESAROVY SIFRY
PRCEK      EQU    3                   ;PREDVOLBA CEKANI
                                      ;BLOK HLASENI NA OBRAZOVKU
UVOD       DB     'PROGRAM ELEKTRONICKY ZAMEK NA KOD.'
ZADANU     DB     '   Zadej uzivatelske heslo: $'
ZADANP     DB     '   Zadej programatorske heslo: $'
HLUZV      DB     'UZAVREN.'
HLOTV      DB     'OTEVREN.'
HLCHY      DB     'CHYBNE.'
SIFRA      DB     'RNWJP'             ;HESLO UZIVATELE
PHES       DB     'UWLM'              ;HESLO PROGRAMATORA
KONRET     DB     '.'                 ;ZNACKA KONEC RETEZCE
MEZERA     DB     ' '                 ;JEDEN MEZERNIK
HVEZD      DB     '*'                 ;HVEZDICKA

           .CODE                      ;PROGRAMOVY SEGMENT
START:     MOV    AX,@DATA            ;UMISTENI DATOVEHO SEGMENTU
           MOV    DS,AX
           MOV    DI,OFFSET UVOD      ;TISK UVODNICH HLASENI
           CALL   TISK
           MOV    DH,10D
           CALL   MEZERY
           MOV    DI,OFFSET HLUZV
           CALL   TISK
           MOV    BH,OPRAV            ;POCITADLO CHYB
           MOV    BL,DELUZV           ;DELKA UZIVATELSKEHO HESLA
           MOV    SI,OFFSET SIFRA     ;ADRESA HESLA UZIVATELE
           MOV    DX,OFFSET ZADANU    ;TISK VYZVY NA OBRAZOVKU
           MOV    AH,09               ;SLUZBA OS TISK RETEZCE
           INT    21H
SMYC:      CALL   KLAVES
           CMP    CL,0                ;VYPRSEL CAS PRI VSTUPU ZNAKU?
           JNZ    ZNAK                ;VETVICI PODMINKA
           DEC    BH                  ;VYPRSEL CAS, UBER CHYBU
           JMP    SHORT UZEL
ZNAK:      MOV    AH,02               ;SLUZBA OS TISK ZNAKU
           MOV    DL,08               ;KOD ASCII ZNAKU BACK SPACE
           INT    21H                 ;KURZOR ZPET S VYMAZEM
           MOV    AH,02
           MOV    DL,HVEZD            ;VOLNE MISTO ZAPLACNI HVEZDICKOU
           INT    21H
           MOV    AH,[SI]             ;NACTENI ZNAKU HESLA Z PAMETI
           SUB    AH,KLIC             ;DEKODOVANI HESLA
           CMP    CL,AH               ;POROVNANI JEHO SPRAVNOSTI
           JZ     SPRAVNE             ;VETVENI
           DEC    BH                  ;CHYBNY ZNAK - SNIZIT POCET CHYB
           JMP    SHORT UZEL
SPRAVNE:   INC    SI                  ;SPRAVNY ZNAK - NOVY ZNAK
           DEC    BL
UZEL:      JNZ    SMYC                ;OPAKUJ - DALSI PISMENO
           MOV    AH,02
           MOV    DL,0AH              ;PRECHOD NA NOVY RADEK (LF)
           INT    21H
           MOV    DL,0DH              ;NAVRAT KURZORU (CR)
           INT    21H
           CMP    BH,0                ;DOSLO K VYCERPANI CHYB?
           JZ     VYCERP              ;ANO
           MOV    DI,OFFSET HLOTV     ;PRI SPRAVNEM HESLE
           CALL   TISK                ;OTEVRIT ZAMEK
           JMP    SHORT KONEC
VYCERP:    MOV    DI,OFFSET HLCHY     ;PRI CHYBNEM HESLE UPOZORNENI
           CALL   TISK                ;NECHAT UZAVRENY ZAMEK
           MOV    BL,DELPRG           ;DELKA UZIVATELSKEHO HESLA
           MOV    SI,OFFSET PHES      ;ADRESA HESLA UZIVATELE
           MOV    DX,OFFSET ZADANP    ;TISK VYZVY NA OBRAZOVKU
           MOV    AH,09               ;SLUZBA OS TISK RETEZCE
           INT    21H
SMYCP:     CALL   KLAPKA
           MOV    AH,02               ;SLUZBA OS TISK ZNAKU
           MOV    DL,08               ;KOD ASCII ZNAKU BACK SPACE
           INT    21H                 ;KURZOR ZPET S VYMAZEM
           MOV    AH,02
           MOV    DL,HVEZD            ;VOLNE MISTO ZAPLACNI HVEZDICKOU
           INT    21H
           MOV    AH,[SI]             ;NACTENI ZNAKU HESLA Z PAMETI
           SUB    AH,KLIC             ;DEKODOVANI HESLA
           CMP    CL,AH               ;POROVNANI JEHO SPRAVNOSTI
           JNZ    FINITO              ;VETVENI
           INC    SI                  ;SPRAVNY ZNAK - NOVY ZNAK
           DEC    BL
           JNZ    SMYCP               ;OPAKUJ - DALSI PISMENO
           MOV    AH,02
           MOV    DL,0AH              ;PRECHOD NA NOVY RADEK (LF)
           INT    21H
           MOV    DL,0DH              ;NAVRAT KURZORU (CR)
           INT    21H
           MOV    DI,OFFSET HLOTV     ;PRI SPRAVNEM HESLE
           CALL   TISK                ;OTEVRIT ZAMEK
           JMP    SHORT KONEC
FINITO:    MOV    AH,02
           MOV    DL,0AH              ;PRECHOD NA NOVY RADEK (LF)
           INT    21H
           MOV    DL,0DH              ;NAVRAT KURZORU (CR)
           INT    21H
           MOV    DI,OFFSET HLCHY     ;PRI CHYBNEM HESLE UPOZORNENI
           CALL   TISK                ;NECHAT UZAVRENY ZAMEK
           ;HALT                      ;TOTALNI ZASTAVENI
KONEC:     MOV    AX,4C00H            ;UKONCENI PROGRAMU
           INT    21H

TISK:      PUSH   DX                  ;TISK RETEZCE NA OBRAZOVKU
           PUSH   DI                  ;USCHOVA REGISTRU
           MOV    DH,DELRAD           ;MAX. DLEKA RETEZCE JAKO RADEK
           MOV    AH,2                ;CISLO FUNKCE SLUZBY OS
CYKL:      MOV    DL,[DI]             ;ZNAK
           INT    21H                 ;TISK ZNAKU
           INC    DI                  ;DALSI ZNAK
           MOV    AL,[DI]
           CMP    AL,KONRET           ;KONEC RETEZCE ? (ZARAZKA)
           JZ     VYCHOD
           DEC    DH                  ;DALSI VYTISTENY ZNAK (POCITADLO)
           JZ     VYCHOD
           JMP    SHORT CYKL          ;ZNOVU, DALSI ZNAKY
VYCHOD:    MOV    DL,0AH              ;PRECHOD NA NOVY RADEK (LF)
           INT    21H
           MOV    DL,0DH              ;NAVRAT KURZORU (CR)
           INT    21H
           POP    DI                  ;OBNOVA OBSAHU REGISTRU
           POP    DX
           RET                        ;NAVRAT Z PODPROGRAMU

MEZERY:    MOV    AH,2
           PUSH   DX
           MOV    DL,MEZERA
CYKLM:     INT    21H
           DEC    DH
           JNZ    CYKLM
           POP    DX
           RET

DELAY:     XOR    AL,AL               ;CEKANI KONSTANTNI DELKY
           XOR    AH,AH
CYKLD1:    DEC    AL                  ;DVA VNORENE CYKLY
CYKLD2:    DEC    AH                  ;OPAKOVANI PEVNEHO ZPOZDENI
           PUSH   AX                  ;ZPOZDOVACI PRIKAZY
           PUSH   BX
           PUSH   CX
           POP    CX
           POP    BX
           POP    AX
           JNZ    CYKLD2
           JNZ    CYKLD1
           RET

CEKEJ:     CALL   DELAY
           DEC    DH                  ;CEKANI PROMENE DELKY
           JNZ    CEKEJ
           RET

KLAVES:    XOR    CL,CL               ;OPAKOVANI TESTU KLAVESNICE
CYKLK:     MOV    DH,PRCEK            ;PREDVOLBA CEKANI
           CALL   CEKEJ
           MOV    AH,0BH              ;TEST KLAVESNICE
           INT    21H
           CMP    AL,0                ;JE NECO STISKNUTO? ANO/NE
           JNZ    KLAPKA              ;POKUD JE NEPOKRACUJ
           DEC    CL                  ;SNIZIT PREDVOLBU
           JNZ    CYKLK               ;ZOPAKUJ - KONEC SMYCKY
           RET                        ;VYPRSEL CAS NA 1 ZNAK - 1. VYCHOD
KLAPKA:    MOV    AH,01               ;BYLA STISKNUTA KLAVESA - 2. VYCHOD
           INT    21H                 ;NACTENI ZNAKU Z BUFFERU KLAVESNICE
           MOV    CL,AL               ;V REG. CL SE VRACI NACTENY ZNAK
           RET                        ;POKUD JE 0, VYPRSEL CASOVY LIMIT

           END    START